import React, { Component } from 'react';
import Hobby from './components/Hobby';
import './App.css';

class App extends Component {
  constructor(props) {
    super(props);
      // déclarer un état...
    		// modele, equivalent du data de VueJS
    		this.state = {
    		  hobbies: ['Football', 'Dessin', 'Lecture'],
        }
  }
  addHobby() {
    const oldElements = this.state.hobbies;
		
		this.setState({
			hobbies: oldElements.concat(this.input.value), // concat retourne un nouveau tableau, pas de push ici !!!
    });

    this.input.value = '';
  }
  removeHobby(hobby) {
    this.setState((state) => {
			const newHobbies = state.hobbies.filter(
         (elem, index) => {
             return (elem !== hobby) ? elem : null;
         }
      );
     return {hobbies: newHobbies};
	  }
  )};
  
  
  // méthodes
  render() {
    let listeHobbies = this.state.hobbies.map(
      (el, index) => {
        return <Hobby key={index}
                      name={el}
                      removeHobby={this.removeHobby.bind(this)}
               >
              {el}
              </Hobby>
      }
    );
    return (
      <div id="app">
        <h1>Liste des hobbies:</h1>
            <p> Nombre de Hobbies: {this.state.hobbies.length} </p>
        <ul>
          {listeHobbies}
        </ul>
        <input
               ref={(input) => this.input = input}
               type="text" 
               placeholder="Ecrivez une hobby .."/>
		    <button onClick={() => this.addHobby()}>Nouveau Hobby</button>

      </div>
    );
  }
}

export default App;
